package at.bestsolution.rsd.rt;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Set;
import java.util.function.BiConsumer;
import java.util.function.BinaryOperator;
import java.util.function.Function;
import java.util.function.Supplier;
import java.util.stream.Collector;

class ArrayCollector<T> implements Collector<T, List<T>, Array<T>> {
	static final Set<Characteristics> CHARACTERISTICS = Collections.emptySet();

	@Override
	public Supplier<List<T>> supplier() {
		return ArrayCollector::internalSupplier;
	}

	@Override
	public BiConsumer<List<T>, T> accumulator() {
		return ArrayCollector::internalAccumulator;
	}

	@Override
	public BinaryOperator<List<T>> combiner() {
		return ArrayCollector::internalCombiner;
	}

	@Override
	public Function<List<T>, Array<T>> finisher() {
		return ArrayCollector::internalFinisher;
	}

	@Override
	public Set<Characteristics> characteristics() {
		return CHARACTERISTICS;
	}

	private static final <T> List<T> internalSupplier() {
		return new ArrayList<>();
	}

	private static final <T> void internalAccumulator(List<T> list, T item) {
		list.add(item);
	}

	private static final <T> List<T> internalCombiner(List<T> left, List<T> right) {
		left.addAll(right);
		return left;
	}

	private static final <T> Array<T> internalFinisher(List<T> list) {
		return new ArrayImpl<T>( list.toArray(), false );
	}
}