package at.bestsolution.rsd.rt;

public class ErrorType<T extends RSDException> {
	public final int errorCode;
	public final int statusCode;
	private final ExceptionCreator<T> exceptionSupplier;

	public ErrorType(int errorCode, int statusCode, ExceptionCreator<T> exceptionSupplier) {
		this.errorCode = errorCode;
		this.statusCode = statusCode;
		this.exceptionSupplier = exceptionSupplier;
	}

	public T asException(Throwable exception, String message, CharSequence errorText) {
		return exceptionSupplier.apply(this, message, exception, errorText);
	}
	
	public T asException(String message, CharSequence errorText) {
		return asException(null,message,errorText);
	}
	
	public T asException(CharSequence errorText) {
		return asException(null, null, errorText);
	}

	@FunctionalInterface
	public interface ExceptionCreator<T extends RSDException> {
		public T apply(ErrorType<?> type, String message, Throwable throwable, CharSequence errorText);
	}
}
