package at.bestsolution.rsd.rt;

class RefImpl<O> implements Ref<O> {
	private final Class<O> type;
	private final String id;
	private final String etag;

	public RefImpl(Class<O> type, String id) {
		this(type, id, null);
	}

	public RefImpl(Class<O> type, String id, String etag) {
		this.type = type;
		this.id = id;
		this.etag = etag;
	}

	@Override
	public String id() {
		return this.id;
	}

	@Override
	public String etag() {
		return etag;
	}

	@Override
	public Class<O> _type() {
		return this.type;
	}

	@Override
	public String toString() {
		return "RefImpl [type=" + type + ", id=" + id + "]";
	}
}