package at.bestsolution.rsd.rt.delta;

import at.bestsolution.rsd.rt.util.BooleanConsumer;

public interface BooleanValue extends Value<Boolean> {
    public static BooleanValue TRUE() {
        return BooleanValueImpl.TRUE;
    }
    
    public static BooleanValue FALSE() {
        return BooleanValueImpl.FALSE;
    }
    
    public static BooleanValue NULL() {
        return BooleanValueImpl.NULL;
    }
    
    public static BooleanValue UNDEFINED() {
        return BooleanValueImpl.UNDEFINED;
    }
    
    public static BooleanValue of(boolean value) {
        return value ? TRUE() : FALSE();
    }
    
    public boolean booleanValue();
    
    public void ifPresent(BooleanConsumer action);
    public void ifDefined(boolean nullValue, BooleanConsumer action);
}
