package at.bestsolution.rsd.rt.delta;

import java.util.function.DoubleConsumer;
import java.util.function.DoubleFunction;
import java.util.function.DoubleUnaryOperator;

public interface DoubleValue extends Value<Double> {
    public static DoubleValue UNDEFINED() {
        return DoubleValueImpl.UNDEFINED;
    }
    
    public static DoubleValue NULL() {
        return DoubleValueImpl.NULL;
    }
    
    public static DoubleValue of(double value) {
        return DoubleValueImpl.of(value);
    }
    
    public double doubleValue();
    public DoubleValue map(DoubleUnaryOperator mapper);
    public <T> Value<T> mapToObj(DoubleFunction<? extends T> mapper);
    
    public void ifPresent(DoubleConsumer action);
    public void ifDefined(double nullValue, DoubleConsumer action);
}
