package at.bestsolution.rsd.rt.delta;

import java.util.function.IntConsumer;
import java.util.function.IntFunction;
import java.util.function.IntUnaryOperator;

public interface IntValue extends Value<Integer> {
    public static IntValue UNDEFINED() {
        return IntValueImpl.UNDEFINED;
    }
    
    public static IntValue NULL() {
        return IntValueImpl.NULL;
    }
    
    public static IntValue of(int value) {
        return IntValueImpl.of(value);
    }
    
    public int intValue();
    public IntValue map(IntUnaryOperator mapper);
    public <T> Value<T> mapToObj(IntFunction<? extends T> mapper);
    
	public void ifPresent(IntConsumer action);
    public void ifDefined(int nullValue, IntConsumer action);
}
