package at.bestsolution.rsd.rt.delta;

import java.util.function.LongConsumer;
import java.util.function.LongFunction;
import java.util.function.LongUnaryOperator;

public interface LongValue extends Value<Long> {
    public static LongValue UNDEFINED() {
        return LongValueImpl.UNDEFINED;
    }
    
    public static LongValue NULL() {
        return LongValueImpl.NULL;
    }
    
    public static LongValue of(long value) {
        return LongValueImpl.of(value);
    }
    
    public long longValue();
    public LongValue map(LongUnaryOperator mapper);
    public <T> Value<T> mapToObj(LongFunction<? extends T> mapper);
    
    public void ifPresent(LongConsumer action);
    public void ifDefined(long nullValue, LongConsumer action);
}
