package at.bestsolution.rsd.rt.delta;

import java.util.function.Consumer;
import java.util.function.Function;
import java.util.function.ToIntFunction;

public interface Value<T> {
    @SuppressWarnings("unchecked")
    public static <T> Value<T> UNDEFINED() {
        return ValueImpl.UNDEFINED;
    }
    
    @SuppressWarnings("unchecked")
    public static <T> Value<T> NULL() {
        return ValueImpl.NULL;
    }

    public static <T> Value<T> of(T value) {
        if( value == null ) {
            return NULL();
        }
        return new ObjectValueImpl<T>(value);
    }

    public <U> Value<U> map(Function<T, U> mapper);
    
    public IntValue mapToInt(ToIntFunction<T> mapper);
    
    public void ifPresent(Consumer<T> action);
    
    public void ifDefined(Consumer<T> action);

    public T value();

    public boolean isUndefined();

    public boolean isDefined();
    
    public boolean isNull();

    public boolean isNotNull();
}
