package at.bestsolution.rsd.rt.interceptor;

/**
 * Specialised exception that adds information to the exceptions thrown invoking
 * an RSD service command
 */
public class RSDInterceptedException extends RuntimeException {

	private static final long serialVersionUID = 1L;

	private final transient MethodInvocationDescriptor invokationDescriptor;

	public RSDInterceptedException(MethodInvocationDescriptor invocationDescriptor) {
		super(invocationDescriptor.exception());
		this.invokationDescriptor = invocationDescriptor;
	}
	
	public MethodInvocationDescriptor getInvocationDescriptor() {
		return invokationDescriptor;
	}

}
