package at.bestsolution.rsd.rt.poll;

import java.io.Serializable;

import at.bestsolution.rsd.rt.Array;

final class PollResultImpl<T> implements PollResult<T>, Serializable {
	/**
	 * 
	 */
	private static final long serialVersionUID = 7831007434991967133L;
	
	private final String stateMarker;
	private final Array<T> result; // NOSONAR @NOSONAR squid:S1948 - false positive - is is a private collection field
	
	@SafeVarargs
	public PollResultImpl(String stateMarker, T... result) {
		this.stateMarker = stateMarker;
		this.result = Array.of(result);
	}
	
	@Override
	public String stateMarker() {
		return stateMarker;
	}

	@Override
	public Array<T> result() {
		return result;
	}

}
