package at.bestsolution.rsd.rt.poll;

import java.util.function.Consumer;
import java.util.function.Function;

import at.bestsolution.rsd.rt.Subscription;

public interface PollingRegistry {
	public <T> Subscription register(Function<String,PollResult<T>> remoteCall, Consumer<T> consumer);
	public Subscription registerVoid(Function<String,PollResult<Void>> remoteCall, Runnable consumer);
	
	public static PollingRegistry createDefaultPolling() {
		return new FastPollingRegistry();
	}
	
	public static PollingRegistry createDefaultPolling(long frequence) {
		return new FastPollingRegistry(frequence);
	}
}
