package at.bestsolution.rsd.rt.rest;

import java.io.InputStream;
import java.util.Map;

import at.bestsolution.rsd.rt.FileStream;

public interface ResponseStream {
	public Map<String,String> headers();
	public InputStream getContent();
	
	public static FileStream toFileStream(ResponseStream stream) {
		String mimeType = stream.headers().getOrDefault("content-type", "application/octet-stream");
		String filename = "";
		String dispoHeader = stream.headers().get("content-disposition");
		int idx;
		if( dispoHeader != null && (idx = dispoHeader.indexOf("filename=")) != -1 ) {
			filename = dispoHeader.substring(idx + "filename=".length()).trim();
		}
		return FileStream.from(stream.getContent(), filename, mimeType);
	}
}
