package at.bestsolution.rsd.rt.util;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.StringReader;

import at.bestsolution.rsd.rt.Array;

public class StringUtil {
	public static final String COMMA = ", ";
	public static final String IDENT = "    ";
	public static final String DOUBLE_COLON = " : ";
	public static final String PROPERTY_FORMAT = "%s"+DOUBLE_COLON+"%s";
	public static final String PROPERTY_FORMAT_WITH_IDENT = IDENT + PROPERTY_FORMAT;
	
	public enum Completeness {
		MINIMAL,
		MEDIUM,
		MAX
	}
	
	public static final TriFunction<Object, Object, String, Completeness> MAX_COMPLETE = (obj,val,attr) -> Completeness.MAX;
	public static final TriFunction<Object, Object, String, Completeness> DEFAULT_COMPLETE = (obj,val,attr) -> val instanceof Array<?> ? StringUtil.Completeness.MEDIUM : StringUtil.Completeness.MINIMAL;
	
	public static String identAllLines(String value) {
		if( value == null ) {
			return "";
		}
		StringBuilder rv = new StringBuilder(value.length());
		BufferedReader r = new BufferedReader(new StringReader(value));
		String line;
		try {
			while( (line = r.readLine()) != null ) {
				if( rv.length() > 0 ) {
					rv.append(IDENT);	
				}
				rv.append(line);
				rv.append("\n");
			}
		} catch (IOException e) {
			throw new IllegalStateException(e);
		}
		return rv.toString();
	}
}
